scoreboard players operation @s dke.edk = $$dke.global dke.edk
scoreboard players operation @s dke.difficulty = $$dke.global dke.difficulty
tag @s add dke.entity
tag @s add dke.end_crystal
tag @s add smithed.entity
tag @s add smithed.strict
#Roll abilities
execute if score @s dke.difficulty matches ..1 if predicate dke:chance_50 store result score @s dke.ability_1 run random value 1..4
execute if score @s dke.difficulty matches ..1 if predicate dke:chance_50 store result score @s dke.ability_2 run random value 2..3
execute if score @s dke.difficulty matches 2..4 if predicate dke:chance_50 store result score @s dke.ability_1 run random value 1..6
execute if score @s dke.difficulty matches 2..4 if predicate dke:chance_50 store result score @s dke.ability_2 run random value 2..6
execute if score @s dke.difficulty matches 3..4 store result score @s dke.ability_3 run random value 2..7
execute if score @s dke.difficulty matches 5.. if predicate dke:chance_50 store result score @s dke.ability_1 run random value 1..9
execute if score @s dke.difficulty matches 5.. store result score @s dke.ability_2 run random value 2..6
execute if score @s dke.difficulty matches 5.. store result score @s dke.ability_3 run random value 7..9
#Ensure certain crystals are unique at any given time
execute if entity @s[predicate=dke:end_crystal/portal] if entity @e[type=end_crystal,predicate=dke:end_crystal/portal,distance=2..] run function dke:crystals/end_crystal_regenerate/end_crystal_unique/unique_portal
execute if entity @s[predicate=dke:end_crystal/cursed] if entity @e[type=end_crystal,predicate=dke:end_crystal/cursed,distance=2..] run function dke:crystals/end_crystal_regenerate/end_crystal_unique/unique_cursed
#Prevent overlap
execute if score @s dke.ability_1 matches ..8 if score @s dke.ability_1 = @s dke.ability_2 run scoreboard players add @s dke.ability_2 1
execute if score @s dke.ability_1 matches 2.. if score @s dke.ability_1 = @s dke.ability_2 run scoreboard players remove @s dke.ability_2 1
execute if score @s dke.ability_1 matches ..8 if score @s dke.ability_1 = @s dke.ability_3 run scoreboard players add @s dke.ability_3 1
execute if score @s dke.ability_1 matches 2.. if score @s dke.ability_1 = @s dke.ability_3 run scoreboard players remove @s dke.ability_3 1
execute if score @s dke.ability_2 matches 1..7 if score @s dke.ability_2 = @s dke.ability_3 run scoreboard players add @s dke.ability_3 2
execute if score @s dke.ability_2 matches 4..9 if score @s dke.ability_2 = @s dke.ability_3 run scoreboard players remove @s dke.ability_3 3
execute if score @s dke.ability_2 matches 3..8 if score @s dke.ability_2 = @s dke.ability_3 run scoreboard players remove @s dke.ability_3 2
execute if predicate dke:end_crystal/caged run place template dke:cage ~-3 ~-2 ~-3 none